/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "../hw/xwin/winprefsyacc.y"

/*
 * Copyright (C) 1994-2000 The XFree86 Project, Inc. All Rights Reserved.
 * Copyright (C) Colin Harrison 2005-2008
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE XFREE86 PROJECT BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of the XFree86 Project
 * shall not be used in advertising or otherwise to promote the sale, use
 * or other dealings in this Software without prior written authorization
 * from the XFree86 Project.
 *
 * Authors:     Earle F. Philhower, III
 *              Colin Harrison
 */
/* $XFree86: $ */

#ifdef HAVE_XWIN_CONFIG_H
#include <xwin-config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#define _STDLIB_H 1 /* bison checks this to know if stdlib has been included */
#include <string.h>
#include "globals.h"
#include "winconfig.h"
#include "winprefs.h"

/* The following give better error messages in bison at the cost of a few KB */
#define YYERROR_VERBOSE 1

/* YYLTYPE_IS_TRIVIAL and YYENABLE_NLS defined to suppress warnings */
#define YYLTYPE_IS_TRIVIAL 1
#define YYENABLE_NLS 0

/* The global pref settings */
WINPREFS pref;

/* The working menu */  
static MENUPARSED menu;

/* Functions for parsing the tokens into out structure */
/* Defined at the end section of this file */

static void SetDPI (char *dpi);
static void SetXKBLayout (char *layout);
static void SetXKBModel (char *model);
static void SetXKBOptions (char *options);
static void SetXKBRules (char *rules);
static void SetXKBVariant (char *variant);

static void SetIconDirectory (char *path);
static void SetDefaultIcon (char *fname);
static void SetRootMenu (char *menu);
static void SetDefaultSysMenu (char *menu, int pos);
static void SetTrayIcon (char *fname);

static void OpenMenu(char *menuname);
static void AddMenuLine(const char *name, MENUCOMMANDTYPE cmd, const char *param);
static void CloseMenu(void);

static void OpenIcons(void);
static void AddIconLine(char *matchstr, char *iconfile);
static void CloseIcons(void);

static void OpenStyles(void);
static void AddStyleLine(char *matchstr, unsigned long style);
static void CloseStyles(void);

static void OpenSysMenu(void);
static void AddSysMenuLine(char *matchstr, char *menuname, int pos);
static void CloseSysMenu(void);

static int yyerror (const char *s);

extern char *yytext;
extern int yylineno;
extern int yylex(void);


#line 169 "hw/xwin/XWin.exe.p/winprefsyacc.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "winprefsyacc.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_NEWLINE = 3,                    /* NEWLINE  */
  YYSYMBOL_MENU = 4,                       /* MENU  */
  YYSYMBOL_LB = 5,                         /* LB  */
  YYSYMBOL_RB = 6,                         /* RB  */
  YYSYMBOL_ICONDIRECTORY = 7,              /* ICONDIRECTORY  */
  YYSYMBOL_DEFAULTICON = 8,                /* DEFAULTICON  */
  YYSYMBOL_ICONS = 9,                      /* ICONS  */
  YYSYMBOL_STYLES = 10,                    /* STYLES  */
  YYSYMBOL_TOPMOST = 11,                   /* TOPMOST  */
  YYSYMBOL_MAXIMIZE = 12,                  /* MAXIMIZE  */
  YYSYMBOL_MINIMIZE = 13,                  /* MINIMIZE  */
  YYSYMBOL_BOTTOM = 14,                    /* BOTTOM  */
  YYSYMBOL_NOTITLE = 15,                   /* NOTITLE  */
  YYSYMBOL_OUTLINE = 16,                   /* OUTLINE  */
  YYSYMBOL_NOFRAME = 17,                   /* NOFRAME  */
  YYSYMBOL_SKIPTASKBAR = 18,               /* SKIPTASKBAR  */
  YYSYMBOL_DEFAULTSYSMENU = 19,            /* DEFAULTSYSMENU  */
  YYSYMBOL_SYSMENU = 20,                   /* SYSMENU  */
  YYSYMBOL_ROOTMENU = 21,                  /* ROOTMENU  */
  YYSYMBOL_SEPARATOR = 22,                 /* SEPARATOR  */
  YYSYMBOL_ATSTART = 23,                   /* ATSTART  */
  YYSYMBOL_ATEND = 24,                     /* ATEND  */
  YYSYMBOL_EXEC = 25,                      /* EXEC  */
  YYSYMBOL_ALWAYSONTOP = 26,               /* ALWAYSONTOP  */
  YYSYMBOL_DEBUGOUTPUT = 27,               /* "DEBUG"  */
  YYSYMBOL_RELOAD = 28,                    /* RELOAD  */
  YYSYMBOL_TRAYICON = 29,                  /* TRAYICON  */
  YYSYMBOL_FORCEEXIT = 30,                 /* FORCEEXIT  */
  YYSYMBOL_SILENTEXIT = 31,                /* SILENTEXIT  */
  YYSYMBOL_DPI = 32,                       /* DPI  */
  YYSYMBOL_XKBLAYOUT = 33,                 /* XKBLAYOUT  */
  YYSYMBOL_XKBMODEL = 34,                  /* XKBMODEL  */
  YYSYMBOL_XKBOPTIONS = 35,                /* XKBOPTIONS  */
  YYSYMBOL_XKBRULES = 36,                  /* XKBRULES  */
  YYSYMBOL_XKBVARIANT = 37,                /* XKBVARIANT  */
  YYSYMBOL_STRING = 38,                    /* STRING  */
  YYSYMBOL_YYACCEPT = 39,                  /* $accept  */
  YYSYMBOL_input = 40,                     /* input  */
  YYSYMBOL_line = 41,                      /* line  */
  YYSYMBOL_newline_or_nada = 42,           /* newline_or_nada  */
  YYSYMBOL_command = 43,                   /* command  */
  YYSYMBOL_dpi = 44,                       /* dpi  */
  YYSYMBOL_xkblayout = 45,                 /* xkblayout  */
  YYSYMBOL_xkbmodel = 46,                  /* xkbmodel  */
  YYSYMBOL_xkboptions = 47,                /* xkboptions  */
  YYSYMBOL_xkbrules = 48,                  /* xkbrules  */
  YYSYMBOL_xkbvariant = 49,                /* xkbvariant  */
  YYSYMBOL_trayicon = 50,                  /* trayicon  */
  YYSYMBOL_rootmenu = 51,                  /* rootmenu  */
  YYSYMBOL_defaultsysmenu = 52,            /* defaultsysmenu  */
  YYSYMBOL_defaulticon = 53,               /* defaulticon  */
  YYSYMBOL_icondirectory = 54,             /* icondirectory  */
  YYSYMBOL_menuline = 55,                  /* menuline  */
  YYSYMBOL_menulist = 56,                  /* menulist  */
  YYSYMBOL_menu = 57,                      /* menu  */
  YYSYMBOL_58_1 = 58,                      /* $@1  */
  YYSYMBOL_iconline = 59,                  /* iconline  */
  YYSYMBOL_iconlist = 60,                  /* iconlist  */
  YYSYMBOL_icons = 61,                     /* icons  */
  YYSYMBOL_62_2 = 62,                      /* $@2  */
  YYSYMBOL_group1 = 63,                    /* group1  */
  YYSYMBOL_group2 = 64,                    /* group2  */
  YYSYMBOL_group3 = 65,                    /* group3  */
  YYSYMBOL_stylecombo = 66,                /* stylecombo  */
  YYSYMBOL_styleline = 67,                 /* styleline  */
  YYSYMBOL_stylelist = 68,                 /* stylelist  */
  YYSYMBOL_styles = 69,                    /* styles  */
  YYSYMBOL_70_3 = 70,                      /* $@3  */
  YYSYMBOL_atspot = 71,                    /* atspot  */
  YYSYMBOL_sysmenuline = 72,               /* sysmenuline  */
  YYSYMBOL_sysmenulist = 73,               /* sysmenulist  */
  YYSYMBOL_sysmenu = 74,                   /* sysmenu  */
  YYSYMBOL_75_4 = 75,                      /* $@4  */
  YYSYMBOL_forceexit = 76,                 /* forceexit  */
  YYSYMBOL_silentexit = 77,                /* silentexit  */
  YYSYMBOL_debug = 78                      /* debug  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   140

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  39
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  40
/* YYNRULES -- Number of rules.  */
#define YYNRULES  89
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  157

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   293


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   150,   150,   151,   154,   155,   159,   160,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   183,   186,   189,   192,
     195,   198,   201,   204,   207,   210,   213,   216,   217,   218,
     219,   220,   223,   224,   227,   227,   230,   233,   234,   237,
     237,   240,   241,   242,   243,   246,   247,   248,   251,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   271,   274,   275,   278,   278,   281,
     282,   283,   286,   289,   290,   293,   293,   296,   299,   302
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "NEWLINE", "MENU",
  "LB", "RB", "ICONDIRECTORY", "DEFAULTICON", "ICONS", "STYLES", "TOPMOST",
  "MAXIMIZE", "MINIMIZE", "BOTTOM", "NOTITLE", "OUTLINE", "NOFRAME",
  "SKIPTASKBAR", "DEFAULTSYSMENU", "SYSMENU", "ROOTMENU", "SEPARATOR",
  "ATSTART", "ATEND", "EXEC", "ALWAYSONTOP", "\"DEBUG\"", "RELOAD",
  "TRAYICON", "FORCEEXIT", "SILENTEXIT", "DPI", "XKBLAYOUT", "XKBMODEL",
  "XKBOPTIONS", "XKBRULES", "XKBVARIANT", "STRING", "$accept", "input",
  "line", "newline_or_nada", "command", "dpi", "xkblayout", "xkbmodel",
  "xkboptions", "xkbrules", "xkbvariant", "trayicon", "rootmenu",
  "defaultsysmenu", "defaulticon", "icondirectory", "menuline", "menulist",
  "menu", "$@1", "iconline", "iconlist", "icons", "$@2", "group1",
  "group2", "group3", "stylecombo", "styleline", "stylelist", "styles",
  "$@3", "atspot", "sysmenuline", "sysmenulist", "sysmenu", "$@4",
  "forceexit", "silentexit", "debug", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-104)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -104,     1,  -104,  -104,   -35,   -26,   -20,    34,    38,     3,
      39,    13,    14,    21,    60,    62,    28,    35,    46,    49,
      50,    63,  -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,
    -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,
    -104,  -104,    67,    99,   100,  -104,  -104,    -7,   101,   102,
     103,   104,  -104,  -104,   105,   106,   107,   108,   109,   110,
    -104,  -104,  -104,   111,   111,  -104,  -104,   112,  -104,  -104,
    -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,   111,   111,
      78,    80,  -104,   111,    -9,  -104,    81,    78,   114,    65,
      80,   115,    84,   120,    -2,    -9,   118,   122,  -104,  -104,
    -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,    53,    36,
      79,   123,  -104,  -104,    89,    84,   124,   111,    90,    91,
     128,   129,  -104,  -104,   111,   116,    40,   116,    86,    40,
      86,   111,    -7,  -104,  -104,  -104,   130,   132,   111,   111,
    -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,   133,   111,
     111,  -104,  -104,   111,  -104,  -104,  -104
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     5,    20,    21,    22,    23,    24,    25,
      17,    14,    15,     8,     9,    10,    11,    12,    13,    18,
      19,    16,     0,     0,     0,    49,    77,    79,     0,     0,
       0,     0,    87,    88,     0,     0,     0,     0,     0,     0,
      44,    36,    35,     6,     6,    80,    81,     0,    85,    33,
      89,    32,    26,    27,    28,    29,    30,    31,     6,     6,
       0,     0,    34,     6,     0,     7,     0,    47,     0,     0,
      75,     0,     0,     0,     0,    42,     0,     0,    48,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,     0,    76,    78,     0,    83,     0,     6,     0,     0,
       0,     0,    43,    45,     6,    62,    63,    64,    65,    66,
      67,     6,    79,    84,    86,    37,     0,     0,     6,     6,
      46,    68,    69,    70,    71,    72,    73,    74,     0,     6,
       6,    38,    41,     6,    40,    39,    82
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
    -104,  -104,  -104,   -64,  -104,  -104,  -104,  -104,  -104,  -104,
    -104,  -104,  -104,  -104,  -104,  -104,  -104,    22,  -104,  -104,
    -104,    51,  -104,  -104,  -103,   -68,   -63,  -104,  -104,    47,
    -104,  -104,     7,  -104,    25,  -104,  -104,  -104,  -104,  -104
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,    22,    80,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    95,    96,    35,    78,
      87,    88,    36,    63,   108,   109,   110,   111,    90,    91,
      37,    64,    67,   115,   116,    38,    83,    39,    40,    41
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      81,     2,   118,    42,     3,     4,   127,   129,     5,     6,
       7,     8,    43,    93,    84,    85,    65,    66,    44,    92,
       9,    10,    11,   119,   120,   144,   121,   146,    12,    94,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    45,
     125,    47,   130,    46,    48,   126,   128,   100,   101,   102,
     103,    49,    50,   135,   107,   104,   105,   106,   142,    51,
     140,   145,   141,    52,   143,    53,    54,   147,   104,   105,
     106,   107,    60,    55,   151,   152,   100,   101,   102,   103,
     104,   105,   106,   107,    56,   154,   155,    57,    58,   156,
     100,   101,   102,   103,   104,   105,   106,   100,   101,   102,
     103,    59,    61,    62,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    79,    82,    86,   122,    89,    97,
      99,   113,   114,   117,   123,   124,   131,   132,   136,   137,
     134,   138,   139,   149,   107,   150,   153,   112,    98,   148,
     133
};

static const yytype_uint8 yycheck[] =
{
      64,     0,     4,    38,     3,     4,   109,   110,     7,     8,
       9,    10,    38,    22,    78,    79,    23,    24,    38,    83,
      19,    20,    21,    25,    26,   128,    28,   130,    27,    38,
      29,    30,    31,    32,    33,    34,    35,    36,    37,     5,
     108,    38,   110,     5,     5,   108,   109,    11,    12,    13,
      14,    38,    38,   117,    18,    15,    16,    17,   126,    38,
     124,   129,   125,     3,   127,     3,    38,   131,    15,    16,
      17,    18,     5,    38,   138,   139,    11,    12,    13,    14,
      15,    16,    17,    18,    38,   149,   150,    38,    38,   153,
      11,    12,    13,    14,    15,    16,    17,    11,    12,    13,
      14,    38,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,    38,    95,    38,    38,
       6,     6,    38,     3,     6,     3,     3,    38,    38,    38,
       6,     3,     3,     3,    18,     3,     3,    90,    87,   132,
     115
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    40,     0,     3,     4,     7,     8,     9,    10,    19,
      20,    21,    27,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    41,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    57,    61,    69,    74,    76,
      77,    78,    38,    38,    38,     5,     5,    38,     5,    38,
      38,    38,     3,     3,    38,    38,    38,    38,    38,    38,
       5,     3,     3,    62,    70,    23,    24,    71,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,    58,     3,
      42,    42,     3,    75,    42,    42,    38,    59,    60,    38,
      67,    68,    42,    22,    38,    55,    56,    38,    60,     6,
      11,    12,    13,    14,    15,    16,    17,    18,    63,    64,
      65,    66,    68,     6,    38,    72,    73,     3,     4,    25,
      26,    28,    56,     6,     3,    64,    65,    63,    65,    63,
      64,     3,    38,    73,     6,    42,    38,    38,     3,     3,
      42,    65,    64,    65,    63,    64,    63,    42,    71,     3,
       3,    42,    42,     3,    42,    42,    42
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    39,    40,    40,    41,    41,    42,    42,    43,    43,
      43,    43,    43,    43,    43,    43,    43,    43,    43,    43,
      43,    43,    43,    43,    43,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    55,    55,
      55,    55,    56,    56,    58,    57,    59,    60,    60,    62,
      61,    63,    63,    63,    63,    64,    64,    64,    65,    66,
      66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    67,    68,    68,    70,    69,    71,
      71,    71,    72,    73,    73,    75,    74,    76,    77,    78
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     3,     4,     5,
       5,     4,     1,     2,     0,     7,     4,     1,     2,     0,
       6,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     4,     1,     2,     0,     6,     0,
       1,     1,     5,     1,     2,     0,     7,     2,     2,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 26: /* dpi: DPI STRING NEWLINE  */
#line 183 "../hw/xwin/winprefsyacc.y"
                                   { SetDPI((yyvsp[-1].sVal)); free((yyvsp[-1].sVal)); }
#line 1339 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 27: /* xkblayout: XKBLAYOUT STRING NEWLINE  */
#line 186 "../hw/xwin/winprefsyacc.y"
                                         { SetXKBLayout((yyvsp[-1].sVal)); }
#line 1345 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 28: /* xkbmodel: XKBMODEL STRING NEWLINE  */
#line 189 "../hw/xwin/winprefsyacc.y"
                                        { SetXKBModel((yyvsp[-1].sVal)); }
#line 1351 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 29: /* xkboptions: XKBOPTIONS STRING NEWLINE  */
#line 192 "../hw/xwin/winprefsyacc.y"
                                          { SetXKBOptions((yyvsp[-1].sVal)); }
#line 1357 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 30: /* xkbrules: XKBRULES STRING NEWLINE  */
#line 195 "../hw/xwin/winprefsyacc.y"
                                        { SetXKBRules((yyvsp[-1].sVal)); }
#line 1363 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 31: /* xkbvariant: XKBVARIANT STRING NEWLINE  */
#line 198 "../hw/xwin/winprefsyacc.y"
                                          { SetXKBVariant((yyvsp[-1].sVal)); }
#line 1369 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 32: /* trayicon: TRAYICON STRING NEWLINE  */
#line 201 "../hw/xwin/winprefsyacc.y"
                                        { SetTrayIcon((yyvsp[-1].sVal)); free((yyvsp[-1].sVal)); }
#line 1375 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 33: /* rootmenu: ROOTMENU STRING NEWLINE  */
#line 204 "../hw/xwin/winprefsyacc.y"
                                        { SetRootMenu((yyvsp[-1].sVal)); free((yyvsp[-1].sVal)); }
#line 1381 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 34: /* defaultsysmenu: DEFAULTSYSMENU STRING atspot NEWLINE  */
#line 207 "../hw/xwin/winprefsyacc.y"
                                                     { SetDefaultSysMenu((yyvsp[-2].sVal), (yyvsp[-1].iVal)); free((yyvsp[-2].sVal)); }
#line 1387 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 35: /* defaulticon: DEFAULTICON STRING NEWLINE  */
#line 210 "../hw/xwin/winprefsyacc.y"
                                           { SetDefaultIcon((yyvsp[-1].sVal)); free((yyvsp[-1].sVal)); }
#line 1393 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 36: /* icondirectory: ICONDIRECTORY STRING NEWLINE  */
#line 213 "../hw/xwin/winprefsyacc.y"
                                             { SetIconDirectory((yyvsp[-1].sVal)); free((yyvsp[-1].sVal)); }
#line 1399 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 37: /* menuline: SEPARATOR NEWLINE newline_or_nada  */
#line 216 "../hw/xwin/winprefsyacc.y"
                                                   { AddMenuLine("-", CMD_SEPARATOR, ""); }
#line 1405 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 38: /* menuline: STRING ALWAYSONTOP NEWLINE newline_or_nada  */
#line 217 "../hw/xwin/winprefsyacc.y"
                                                      { AddMenuLine((yyvsp[-3].sVal), CMD_ALWAYSONTOP, ""); free((yyvsp[-3].sVal)); }
#line 1411 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 39: /* menuline: STRING EXEC STRING NEWLINE newline_or_nada  */
#line 218 "../hw/xwin/winprefsyacc.y"
                                                      { AddMenuLine((yyvsp[-4].sVal), CMD_EXEC, (yyvsp[-2].sVal)); free((yyvsp[-4].sVal)); free((yyvsp[-2].sVal)); }
#line 1417 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 40: /* menuline: STRING MENU STRING NEWLINE newline_or_nada  */
#line 219 "../hw/xwin/winprefsyacc.y"
                                                      { AddMenuLine((yyvsp[-4].sVal), CMD_MENU, (yyvsp[-2].sVal)); free((yyvsp[-4].sVal)); free((yyvsp[-2].sVal)); }
#line 1423 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 41: /* menuline: STRING RELOAD NEWLINE newline_or_nada  */
#line 220 "../hw/xwin/winprefsyacc.y"
                                                 { AddMenuLine((yyvsp[-3].sVal), CMD_RELOAD, ""); free((yyvsp[-3].sVal)); }
#line 1429 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 44: /* $@1: %empty  */
#line 227 "../hw/xwin/winprefsyacc.y"
                       { OpenMenu((yyvsp[-1].sVal)); free((yyvsp[-1].sVal)); }
#line 1435 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 45: /* menu: MENU STRING LB $@1 newline_or_nada menulist RB  */
#line 227 "../hw/xwin/winprefsyacc.y"
                                                                               {CloseMenu();}
#line 1441 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 46: /* iconline: STRING STRING NEWLINE newline_or_nada  */
#line 230 "../hw/xwin/winprefsyacc.y"
                                                      { AddIconLine((yyvsp[-3].sVal), (yyvsp[-2].sVal)); free((yyvsp[-3].sVal)); free((yyvsp[-2].sVal)); }
#line 1447 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 49: /* $@2: %empty  */
#line 237 "../hw/xwin/winprefsyacc.y"
                 {OpenIcons();}
#line 1453 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 50: /* icons: ICONS LB $@2 newline_or_nada iconlist RB  */
#line 237 "../hw/xwin/winprefsyacc.y"
                                                            {CloseIcons();}
#line 1459 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 51: /* group1: TOPMOST  */
#line 240 "../hw/xwin/winprefsyacc.y"
                { (yyval.uVal)=STYLE_TOPMOST; }
#line 1465 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 52: /* group1: MAXIMIZE  */
#line 241 "../hw/xwin/winprefsyacc.y"
                   { (yyval.uVal)=STYLE_MAXIMIZE; }
#line 1471 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 53: /* group1: MINIMIZE  */
#line 242 "../hw/xwin/winprefsyacc.y"
                   { (yyval.uVal)=STYLE_MINIMIZE; }
#line 1477 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 54: /* group1: BOTTOM  */
#line 243 "../hw/xwin/winprefsyacc.y"
                 { (yyval.uVal)=STYLE_BOTTOM; }
#line 1483 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 55: /* group2: NOTITLE  */
#line 246 "../hw/xwin/winprefsyacc.y"
                { (yyval.uVal)=STYLE_NOTITLE; }
#line 1489 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 56: /* group2: OUTLINE  */
#line 247 "../hw/xwin/winprefsyacc.y"
                  { (yyval.uVal)=STYLE_OUTLINE; }
#line 1495 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 57: /* group2: NOFRAME  */
#line 248 "../hw/xwin/winprefsyacc.y"
                  { (yyval.uVal)=STYLE_NOFRAME; }
#line 1501 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 58: /* group3: SKIPTASKBAR  */
#line 251 "../hw/xwin/winprefsyacc.y"
                    { (yyval.uVal)=STYLE_SKIPTASKBAR; }
#line 1507 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 59: /* stylecombo: group1  */
#line 254 "../hw/xwin/winprefsyacc.y"
                       { (yyval.uVal)=(yyvsp[0].uVal); }
#line 1513 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 60: /* stylecombo: group2  */
#line 255 "../hw/xwin/winprefsyacc.y"
                 { (yyval.uVal)=(yyvsp[0].uVal); }
#line 1519 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 61: /* stylecombo: group3  */
#line 256 "../hw/xwin/winprefsyacc.y"
                 { (yyval.uVal)=(yyvsp[0].uVal); }
#line 1525 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 62: /* stylecombo: group1 group2  */
#line 257 "../hw/xwin/winprefsyacc.y"
                        { (yyval.uVal)=(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1531 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 63: /* stylecombo: group1 group3  */
#line 258 "../hw/xwin/winprefsyacc.y"
                        { (yyval.uVal)=(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1537 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 64: /* stylecombo: group2 group1  */
#line 259 "../hw/xwin/winprefsyacc.y"
                        { (yyval.uVal)=(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1543 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 65: /* stylecombo: group2 group3  */
#line 260 "../hw/xwin/winprefsyacc.y"
                        { (yyval.uVal)=(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1549 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 66: /* stylecombo: group3 group1  */
#line 261 "../hw/xwin/winprefsyacc.y"
                        { (yyval.uVal)=(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1555 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 67: /* stylecombo: group3 group2  */
#line 262 "../hw/xwin/winprefsyacc.y"
                        { (yyval.uVal)=(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1561 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 68: /* stylecombo: group1 group2 group3  */
#line 263 "../hw/xwin/winprefsyacc.y"
                               { (yyval.uVal)=(yyvsp[-2].uVal)|(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1567 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 69: /* stylecombo: group1 group3 group2  */
#line 264 "../hw/xwin/winprefsyacc.y"
                               { (yyval.uVal)=(yyvsp[-2].uVal)|(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1573 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 70: /* stylecombo: group2 group1 group3  */
#line 265 "../hw/xwin/winprefsyacc.y"
                               { (yyval.uVal)=(yyvsp[-2].uVal)|(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1579 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 71: /* stylecombo: group2 group3 group1  */
#line 266 "../hw/xwin/winprefsyacc.y"
                               { (yyval.uVal)=(yyvsp[-2].uVal)|(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1585 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 72: /* stylecombo: group3 group1 group2  */
#line 267 "../hw/xwin/winprefsyacc.y"
                               { (yyval.uVal)=(yyvsp[-2].uVal)|(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1591 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 73: /* stylecombo: group3 group2 group1  */
#line 268 "../hw/xwin/winprefsyacc.y"
                               { (yyval.uVal)=(yyvsp[-2].uVal)|(yyvsp[-1].uVal)|(yyvsp[0].uVal); }
#line 1597 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 74: /* styleline: STRING stylecombo NEWLINE newline_or_nada  */
#line 271 "../hw/xwin/winprefsyacc.y"
                                                          { AddStyleLine((yyvsp[-3].sVal), (yyvsp[-2].uVal)); free((yyvsp[-3].sVal)); }
#line 1603 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 77: /* $@3: %empty  */
#line 278 "../hw/xwin/winprefsyacc.y"
                  {OpenStyles();}
#line 1609 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 78: /* styles: STYLES LB $@3 newline_or_nada stylelist RB  */
#line 278 "../hw/xwin/winprefsyacc.y"
                                                               {CloseStyles();}
#line 1615 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 79: /* atspot: %empty  */
#line 281 "../hw/xwin/winprefsyacc.y"
        { (yyval.iVal)=AT_END; }
#line 1621 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 80: /* atspot: ATSTART  */
#line 282 "../hw/xwin/winprefsyacc.y"
                  { (yyval.iVal)=AT_START; }
#line 1627 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 81: /* atspot: ATEND  */
#line 283 "../hw/xwin/winprefsyacc.y"
                { (yyval.iVal)=AT_END; }
#line 1633 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 82: /* sysmenuline: STRING STRING atspot NEWLINE newline_or_nada  */
#line 286 "../hw/xwin/winprefsyacc.y"
                                                             { AddSysMenuLine((yyvsp[-4].sVal), (yyvsp[-3].sVal), (yyvsp[-2].iVal)); free((yyvsp[-4].sVal)); free((yyvsp[-3].sVal)); }
#line 1639 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 85: /* $@4: %empty  */
#line 293 "../hw/xwin/winprefsyacc.y"
                                   {OpenSysMenu();}
#line 1645 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 86: /* sysmenu: SYSMENU LB NEWLINE $@4 newline_or_nada sysmenulist RB  */
#line 293 "../hw/xwin/winprefsyacc.y"
                                                                                   {CloseSysMenu();}
#line 1651 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 87: /* forceexit: FORCEEXIT NEWLINE  */
#line 296 "../hw/xwin/winprefsyacc.y"
                                  { pref.fForceExit = TRUE; }
#line 1657 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 88: /* silentexit: SILENTEXIT NEWLINE  */
#line 299 "../hw/xwin/winprefsyacc.y"
                                   { pref.fSilentExit = TRUE; }
#line 1663 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;

  case 89: /* debug: "DEBUG" STRING NEWLINE  */
#line 302 "../hw/xwin/winprefsyacc.y"
                                   { ErrorF("LoadPreferences: %s\n", (yyvsp[-1].sVal)); free((yyvsp[-1].sVal)); }
#line 1669 "hw/xwin/XWin.exe.p/winprefsyacc.c"
    break;


#line 1673 "hw/xwin/XWin.exe.p/winprefsyacc.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 306 "../hw/xwin/winprefsyacc.y"

/*
 * Errors in parsing abort and print log messages
 */
static int
yyerror (const char *s)
{
  ErrorF("LoadPreferences: %s line %d\n", s, yylineno);
  return 1;
}

static void
SetDPI (char *dpi)
{
  if (!g_cmdline.customDPI)
      {
          monitorResolution = atoi (dpi);
          g_fixedDPI = TRUE;
      }
}

static void
SetXKBLayout (char *layout)
{
  if (!g_cmdline.xkbLayout)
    g_cmdline.xkbLayout = layout;
  else
    free (layout);
}

static void
SetXKBModel (char *model)
{
  if (!g_cmdline.xkbModel)
    g_cmdline.xkbModel = model;
  else
    free (model);
}

static void
SetXKBOptions (char *options)
{
  if (!g_cmdline.xkbOptions)
    g_cmdline.xkbOptions = options;
  else
    free (options);
}

static void
SetXKBRules (char *rules)
{
  if (!g_cmdline.xkbRules)
    g_cmdline.xkbRules = rules;
  else
    free (rules);
}

static void
SetXKBVariant (char *variant)
{
  if (!g_cmdline.xkbVariant)
    g_cmdline.xkbVariant = variant;
  else
    free (variant);
}

/* Miscellaneous functions to store TOKENs into the structure */
static void
SetIconDirectory (char *path)
{
  strncpy (pref.iconDirectory, path, PATH_MAX);
  pref.iconDirectory[PATH_MAX] = 0;
}

static void
SetDefaultIcon (char *fname)
{
  strncpy (pref.defaultIconName, fname, NAME_MAX);
  pref.defaultIconName[NAME_MAX] = 0;
}

static void
SetTrayIcon (char *fname)
{
  strncpy (pref.trayIconName, fname, NAME_MAX);
  pref.trayIconName[NAME_MAX] = 0;
}

static void
SetRootMenu (char *menuname)
{
  strncpy (pref.rootMenuName, menuname, MENU_MAX);
  pref.rootMenuName[MENU_MAX] = 0;
}

static void
SetDefaultSysMenu (char *menuname, int pos)
{
  strncpy (pref.defaultSysMenuName, menuname, MENU_MAX);
  pref.defaultSysMenuName[MENU_MAX] = 0;
  pref.defaultSysMenuPos = pos;
}

static void
OpenMenu (char *menuname)
{
  if (menu.menuItem) free(menu.menuItem);
  menu.menuItem = NULL;
  strncpy(menu.menuName, menuname, MENU_MAX);
  menu.menuName[MENU_MAX] = 0;
  menu.menuItems = 0;
}

static void
AddMenuLine (const char *text, MENUCOMMANDTYPE cmd, const char *param)
{
  if (menu.menuItem==NULL)
    menu.menuItem = malloc(sizeof(MENUITEM));
  else
    menu.menuItem = realloc(menu.menuItem, sizeof(MENUITEM)*(menu.menuItems+1));

  strncpy (menu.menuItem[menu.menuItems].text, text, MENU_MAX);
  menu.menuItem[menu.menuItems].text[MENU_MAX] = 0;

  menu.menuItem[menu.menuItems].cmd = cmd;

  strncpy(menu.menuItem[menu.menuItems].param, param, PARAM_MAX);
  menu.menuItem[menu.menuItems].param[PARAM_MAX] = 0;

  menu.menuItem[menu.menuItems].commandID = 0;

  menu.menuItems++;
}

static void
CloseMenu (void)
{
  if (menu.menuItem==NULL || menu.menuItems==0)
    {
      ErrorF("LoadPreferences: Empty menu detected\n");
      return;
    }
  
  if (pref.menuItems)
    pref.menu = realloc (pref.menu, (pref.menuItems+1)*sizeof(MENUPARSED));
  else
    pref.menu = malloc (sizeof(MENUPARSED));
  
  memcpy (pref.menu+pref.menuItems, &menu, sizeof(MENUPARSED));
  pref.menuItems++;

  memset (&menu, 0, sizeof(MENUPARSED));
}

static void 
OpenIcons (void)
{
  if (pref.icon != NULL) {
    ErrorF("LoadPreferences: Redefining icon mappings\n");
    free(pref.icon);
    pref.icon = NULL;
  }
  pref.iconItems = 0;
}

static void
AddIconLine (char *matchstr, char *iconfile)
{
  if (pref.icon==NULL)
    pref.icon = malloc(sizeof(ICONITEM));
  else
    pref.icon = realloc(pref.icon, sizeof(ICONITEM)*(pref.iconItems+1));

  strncpy(pref.icon[pref.iconItems].match, matchstr, MENU_MAX);
  pref.icon[pref.iconItems].match[MENU_MAX] = 0;

  strncpy(pref.icon[pref.iconItems].iconFile, iconfile, PATH_MAX+NAME_MAX+1);
  pref.icon[pref.iconItems].iconFile[PATH_MAX+NAME_MAX+1] = 0;

  pref.icon[pref.iconItems].hicon = 0;

  pref.iconItems++;
}

static void 
CloseIcons (void)
{
}

static void
OpenStyles (void)
{
  if (pref.style != NULL) {
    ErrorF("LoadPreferences: Redefining window style\n");
    free(pref.style);
    pref.style = NULL;
  }
  pref.styleItems = 0;
}

static void
AddStyleLine (char *matchstr, unsigned long style)
{
  if (pref.style==NULL)
    pref.style = malloc(sizeof(STYLEITEM));
  else
    pref.style = realloc(pref.style, sizeof(STYLEITEM)*(pref.styleItems+1));

  strncpy(pref.style[pref.styleItems].match, matchstr, MENU_MAX);
  pref.style[pref.styleItems].match[MENU_MAX] = 0;

  pref.style[pref.styleItems].type = style;

  pref.styleItems++;
}

static void
CloseStyles (void)
{
}

static void
OpenSysMenu (void)
{
  if (pref.sysMenu != NULL) {
    ErrorF("LoadPreferences: Redefining system menu\n");
    free(pref.sysMenu);
    pref.sysMenu = NULL;
  }
  pref.sysMenuItems = 0;
}

static void
AddSysMenuLine (char *matchstr, char *menuname, int pos)
{
  if (pref.sysMenu==NULL)
    pref.sysMenu = malloc(sizeof(SYSMENUITEM));
  else
    pref.sysMenu = realloc(pref.sysMenu, sizeof(SYSMENUITEM)*(pref.sysMenuItems+1));

  strncpy (pref.sysMenu[pref.sysMenuItems].match, matchstr, MENU_MAX);
  pref.sysMenu[pref.sysMenuItems].match[MENU_MAX] = 0;

  strncpy (pref.sysMenu[pref.sysMenuItems].menuName, menuname, MENU_MAX);
  pref.sysMenu[pref.sysMenuItems].menuName[MENU_MAX] = 0;

  pref.sysMenu[pref.sysMenuItems].menuPos = pos;

  pref.sysMenuItems++;
}

static void
CloseSysMenu (void)
{
}

